defmodule OutlookWeb.ArticleLive.Show do
  use OutlookWeb, :live_view

  alias Outlook.{Articles,InternalTree,Translations}

  @impl true
  def mount(_params, _session, socket) do
    {:ok, socket}
  end

  @impl true
  def handle_params(%{"id" => id}, _, socket) do
    {:noreply, socket
      |> assign(:page_title, page_title(socket.assigns.live_action))
      |> get_and_assign_article(id)}
  end

  @impl true
  def handle_event("delete_translation", %{"id" => id}, socket) do
    translation = Translations.get_translation!(id)
    {:ok, _} = Translations.delete_translation(translation)

    {:noreply, socket |> get_and_assign_article(socket.assigns.article.id)}
  end

  defp get_and_assign_article(socket, id) do
    article = Articles.get_article_with_translations!(id)
    socket
    |> assign(:article_content, InternalTree.garnish(article.content, %{tunits: %{class: "tunit"}}))
    |> assign(:article, article)
  end

  defp page_title(:show), do: "Show Article"
  defp page_title(:edit), do: "Edit Article"
end
